#ifndef lint
static char sccsid[] = "@(#)decode_pex.c 5.1 91/02/12 Copyright 1990, 1991 SMI/MIT";
#endif

/***********************************************************
Copyright 1989, 1990, 1991 by Sun Microsystems, Inc. and the X Consortium.

                        All Rights Reserved

Permission to use, copy, modify, and distribute this software and its 
documentation for any purpose and without fee is hereby granted, 
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in 
supporting documentation, and that the names of Sun Microsystems,
the X Consortium, and MIT not be used in advertising or publicity 
pertaining to distribution of the software without specific, written 
prior permission.  

SUN MICROSYSTEMS DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, 
INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT 
SHALL SUN MICROSYSTEMS BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL 
DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
SOFTWARE.

******************************************************************/
 
#include <stdio.h>
#include "X.h"
#include "PEX.h"
#include "PEXprotost.h"
#include "scope.h"
#include "pexRNames.h"
#include "pexOCNames.h"
#include "pexscope.h"

unsigned char pex_last_req;

BOOL LookForPEXFlag;

CARD8 PEXCode;

pex_decode_req(fd, buf)
FD fd;
unsigned char *buf;
{
	short req = IByte (&buf[0]);

	if ((buf[1] < PEXRCGetExtensionInfo) ||
	    (buf[1] > PEXRCPickAll)) {
	   return;
	} else
	   pex_last_req =buf[1];

	switch (buf[1]) {
	case PEXRCGetExtensionInfo:
		GetExtensionInfo(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetEnumTypeInfo:
		GetEnumeratedTypeInfo(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetImpDepConstants:
		GetImpDepConstants(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCCreateLookupTable:
		CreateLookupTable(buf);
		break;
	case PEXRCCopyLookupTable:
		CopyLookupTable(buf);
		break;
	case PEXRCFreeLookupTable:
		FreeLookupTable(buf);
		break;
	case PEXRCGetTableInfo:
		GetTableInfo(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetPredefinedEntries:
		GetPredefinedEntries(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetDefinedIndices:
		GetDefinedIndices(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetTableEntry:
		GetTableEntry(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetTableEntries:
		GetTableEntries(buf);
		ReplyExpected(fd, buf);
		break;
	case PEXRCSetTableEntries:
		SetTableEntries(buf);
		break;
	case PEXRCDeleteTableEntries:
		DeleteTableEntries(buf);
		break;
	case PEXRCCreatePipelineContext:
		CreatePipelineContext(buf);
		break;
	case PEXRCCopyPipelineContext:
		CopyPipelineContext(buf);
		break;
	case PEXRCFreePipelineContext:
		FreePipelineContext(buf);
		break;
	case PEXRCGetPipelineContext:
		GetPipelineContext(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCChangePipelineContext:
		ChangePipelineContext(buf);
		break;
	case PEXRCCreateRenderer:
		CreateRenderer(buf);
		break;
	case PEXRCFreeRenderer:
		FreeRenderer(buf);
		break;
	case PEXRCChangeRenderer:
		ChangeRenderer(buf);
		break;
	case PEXRCGetRendererAttributes:
		GetRendererAttributes(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCBeginRendering:
		BeginRendering(buf);
		break;
	case PEXRCEndRendering:
		EndRendering(buf);
		break;
	case PEXRCBeginStructure:
		BeginStructure(buf);
		break;
	case PEXRCEndStructure:
		EndStructure(buf);
		break;
	case PEXRCRenderOutputCommands:
		RenderOutputCommands(buf);
		break;
	case PEXRCRenderNetwork:
		RenderNetwork(buf);
		break;
	case PEXRCCreateStructure:
		CreateStructure(buf);
		break;
	case PEXRCCopyStructure:
		CopyStructure(buf);
		break;
	case PEXRCGetRendererDynamics:
		GetRendererDynamics(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCDestroyStructures:
		DestroyStructures(buf);
		break;
	case PEXRCGetStructureInfo:
		GetStructureInfo(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetElementInfo:
		GetElementInfo(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetStructuresInNetwork:
		GetStructuresInNetwork(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetAncestors:
		GetAncestors(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetDescendants:
		GetDescendants(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCFetchElements:
		FetchElements(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCSetEditingMode:
		SetEditingMode(buf);
		break;
	case PEXRCSetElementPointer:
		SetElementPointer(buf);
		break;
	case PEXRCSetElementPointerAtLabel:
		SetElementPointerAtLabel(buf);
		break;
	case PEXRCElementSearch:
		ElementSearch(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCStoreElements:
		StoreElements(buf);
		break;
	case PEXRCDeleteElements:
		DeleteElements(buf);
		break;
	case PEXRCDeleteElementsToLabel:
		DeleteElementsToLabel(buf);
		break;
	case PEXRCDeleteBetweenLabels:
		DeleteBetweenLabels(buf);
		break;
	case PEXRCCopyElements:
		CopyElements(buf);
		break;
	case PEXRCChangeStructureRefs:
		ChangeStructureRefs(buf);
		break;
	case PEXRCCreateNameSet:
		CreateNameSet(buf);
		break;
	case PEXRCCopyNameSet:
		CopyNameSet(buf);
		break;
	case PEXRCFreeNameSet:
		FreeNameSet(buf);
		break;
	case PEXRCGetNameSet:
		GetNameSet(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCChangeNameSet:
		ChangeNameSet(buf);
		break;
	case PEXRCCreateSearchContext:
		CreateSearchContext(buf);
		break;
	case PEXRCCopySearchContext:
		CopySearchContext(buf);
		break;
	case PEXRCFreeSearchContext:
		FreeSearchContext(buf);
		break;
	case PEXRCGetSearchContext:
		GetSearchContext(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCChangeSearchContext:
		ChangeSearchContext(buf);
		break;
	case PEXRCSearchNetwork:
		SearchNetwork(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCCreateWorkstation:
		CreatePhigsWks(buf);
		break;
	case PEXRCFreeWorkstation:
		FreePhigsWks(buf);
		break;
	case PEXRCGetWorkstationAttributes:
		GetWksInfo(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetWorkstationDynamics:
		GetDynamics(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetWorkstationViewRep:
		GetViewRep(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCRedrawAllStructures:
		RedrawAllStructures(buf);
		break;
	case PEXRCUpdateWorkstation:
		UpdateWorkstation(buf);
		break;
	case PEXRCExecuteDeferredActions:
		ExecuteDeferredActions(buf);
		break;
	case PEXRCSetWorkstationViewPriority:
		SetViewPriority(buf);
		break;
	case PEXRCSetWorkstationDisplayUpdateMode:
		SetDisplayUpdateMode(buf);
		break;
	case PEXRCMapDCtoWC:
		MapDCtoWC(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCMapWCtoDC:
		MapWCtoDC(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCSetWorkstationViewRep:
		SetViewRep(buf);
		break;
	case PEXRCSetWorkstationWindow:
		SetWksWindow(buf);
		break;
	case PEXRCSetWorkstationViewport:
		SetWksViewport(buf);
		break;
	case PEXRCSetWorkstationHLHSRMode:
		SetHlhsrMode(buf);
		break;
	case PEXRCPostStructure:
		PostStructure(buf);
		break;
	case PEXRCUnpostStructure:
		UnpostStructure(buf);
		break;
	case PEXRCUnpostAllStructures:
		UnpostAllStructures(buf);
		break;
	case PEXRCGetWorkstationPostings:
		GetWksPostings(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCGetPickDevice:
		GetPickDevice(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCChangePickDevice:
		ChangePickDevice(buf);
		break;
	case PEXRCCreatePickMeasure:
		CreatePickMeasure(buf);
		break;
	case PEXRCFreePickMeasure:
		FreePickMeasure(buf);
		break;
	case PEXRCGetPickMeasure:
		GetPickMeasure(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCUpdatePickMeasure:
		UpdatePickMeasure(buf);
		break;
	case PEXRCLoadFont:
		pexopenfont(buf);
		break;
	case PEXRCUnloadFont:
		pexclosefont(buf);
		break;
	case PEXRCQueryFont:
		pexqueryfont(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCListFonts:
		pexlistfonts(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCListFontsWithInfo:
		pexlistfontswithinfo(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCQueryTextExtents:
		pexquerytextextents(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCRedrawClipRegion:
		RedrawClipRegion(buf);
		break;
	case PEXRCMatchRenderingTargets:
		pexmatchrenderertargets(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCEscape:
		pexescape(buf);
		break;
	case PEXRCEscapeWithReply:
		pexescapewithreply(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCPickOne:
		pexpickone(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCBeginPickOne:
		pexbeginpickone(buf);
		break;
	case PEXRCEndPickOne:
		pexendpickone(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCPickAll:
		pexpickall(buf);
		ReplyExpected(fd, req);
		break;
	case PEXRCBeginPickAll:
		pexbeginpickall(buf);
		break;
	case PEXRCEndPickAll:
		pexendpickall(buf);
		ReplyExpected(fd, req);
		break;
	default:
		break;
	}
}

/*
 *
 *
 *
 */
pex_decode_elem(num_cmds, buf)
CARD32 num_cmds;
unsigned char *buf;
{
	register long i;
	register pexElementInfo *el_info;

	for (i = 0; i < num_cmds; i++) {
		el_info = (pexElementInfo *) buf;
		if ((el_info->elementType <= PEXOCAll) ||
		    (el_info->elementType > PEXOCNoop) )
			return;
		fprintf(stdout, "\t\t\t     %s\n",
		pex_oc_name[el_info->elementType]);

		fprintf(stdout, "\t\t\t     length : %d\n",el_info->length);

#if 0
		if (Verbose >=3){
		  char *b = buf;
		  int j;
		  
		  for (j = 0; j < el_info->length*4; j+=4) {
		    if (j % 40 == 0)
		      fprintf(stdout, "\n");
		    fprintf(stdout, "%02.2x%02.2x%02.2x%02.2x", 
                            b[0], b[1], b[2], b[3]);
		    b+=4;
		  }
		  fprintf(stdout, "\n");
		}
#endif
		buf += el_info->length * 4;
		
#ifdef IGNORE
		switch (el_info->elementType) {
		case PEXOCMarkerType:
			break;
		case PEXOCMarkerScale:
			break;
		case PEXOCMarkerColourIndex:
			break;
		case PEXOCMarkerColour:
			break;
		case PEXOCMarkerBundleIndex:
			break;
		case PEXOCTextFontIndex:
			break;
		case PEXOCTextPrecision:
			break;
		case PEXOCCharExpansion:
			break;
		case PEXOCCharSpacing:
			break;
		case PEXOCTextColourIndex:
			break;
		case PEXOCTextColour:
			break;
		case PEXOCCharHeight:
			break;
		case PEXOCCharUpVector:	
			break;
		case PEXOCTextPath:
			break;
		case PEXOCTextAlignment:
			break;
		case PEXOCAtextHeight:
			break;
		case PEXOCAtextUpVector:
			break;
		case PEXOCAtextPath:
			break;
		case PEXOCAtextAlignment:
			break;
		case PEXOCAtextStyle:	
			break;
		case PEXOCTextBundleIndex:
			break;
		case PEXOCLineType:
			break;
		case PEXOCLineWidth:
			break;
		case PEXOCLineColourIndex:		
			break;
		case PEXOCLineColour:	
			break;
		case PEXOCCurveApproximation:
			break;
		case PEXOCPolylineInterp:
			break;
		case PEXOCLineBundleIndex:
			break;
		case PEXOCInteriorStyle:
			break;
		case PEXOCInteriorStyleIndex:	
			break;
		case PEXOCSurfaceColourIndex:
			break;
		case PEXOCSurfaceColour:
			break;
		case PEXOCSurfaceReflAttr:
			break;
		case PEXOCSurfaceReflModel:
			break;
		case PEXOCSurfaceInterp:
			break;
		case PEXOCBfInteriorStyle:		
			break;
		case PEXOCBfInteriorStyleIndex:
			break;
		case PEXOCBfSurfaceColourIndex:
			break;
		case PEXOCBfSurfaceColour:
			break;
		case PEXOCBfSurfaceReflAttr:
			break;
		case PEXOCBfSurfaceReflModel:
			break;
		case PEXOCBfSurfaceInterp:
			break;
		case PEXOCSurfaceApproximation:
			break;
		case PEXOCTCApproximation:
			break;
		case PEXOCCullingMode:
			break;
		case PEXOCDistinguishFlag:
			break;
		case PEXOCNormalFlip:
			break;
		case PEXOCPatternSize:
			break;
		case PEXOCPatternRefPt:
			break;
		case PEXOCPatternAttr:
			break;
		case PEXOCInteriorBundleIndex:
			break;
		case PEXOCSurfaceEdgeFlag:
			break;
		case PEXOCSurfaceEdgeType:
			break;
		case PEXOCSurfaceEdgeWidth:		
			break;
		case PEXOCSurfaceEdgeColourIndex:
			break;
		case PEXOCSurfaceEdgeColour:
			break;
		case PEXOCEdgeBundleIndex:
			break;
		case PEXOCSetAsfValues:
			break;
		case PEXOCLocalTransform:
			break;
		case PEXOCLocalTransform2D:
			break;
		case PEXOCGlobalTransform:
			break;
		case PEXOCGlobalTransform2D:
			break;
		case PEXOCModelClip:
			break;
		case PEXOCModelClipVolume:	
			break;
		case PEXOCModelClipVolume2D	:
			break;
		case PEXOCRestoreModelClip:
			break;
		case PEXOCViewIndex:
			break;
		case PEXOCLightState:
			break;
		case PEXOCDepthCueIndex:
			break;
		case PEXOCPickId:
			break;
		case PEXOCHlhsrIdentifier:
			break;
		case PEXOCAddToNameSet:
			break;
		case PEXOCRemoveFromNameSet:
			break;
		case PEXOCExecuteStructure:
			break;
		case PEXOCLabel:
			break;
		case PEXOCApplicationData:
			break;
		case PEXOCGse:
			break;
		case PEXOCMarker:
			break;
		case PEXOCMarker2D:
			break;
		case PEXOCText:
			break;
		case PEXOCText2D:
			break;
		case PEXOCAnnotationText:
			break;
		case PEXOCAnnotationText2D:
			break;
		case PEXOCPolyline:
			break;
		case PEXOCPolyline2D:
			break;
		case PEXOCPolylineSet:
			break;
		case PEXOCNurbCurve:		
			break;
		case PEXOCFillArea:	
			break;
		case PEXOCFillArea2D:
			break;
		case PEXOCExtFillArea:
			break;
		case PEXOCFillAreaSet:	
			break;
		case PEXOCFillAreaSet2D:	
			break;
		case PEXOCExtFillAreaSet:		
			break;
		case PEXOCTriangleStrip:	
			break;
		case PEXOCQuadrilateralMesh:	
			break;
		case PEXOCIndexedPolygons:
			break;
		case PEXOCNurbSurface:
			break;
		case PEXOCCellArray:	
			break;
		case PEXOCCellArray2D:
			break;
		case PEXOCExtCellArray:		
			break;
		case PEXOCGdp:
			break;
		case PEXOCGdp2D:
			break;
		case PEXOCColourApproxIndex:
			break;
		default:
			break;
		}
#endif /* IGNORE */
	}
}

/*
 *
 *
 *
 */
pex_decode_reply(fd, buf)
FD fd;
unsigned char *buf;
{
	switch (pex_last_req) {
	case PEXRCGetExtensionInfo:
		GetExtensionInfoReply(buf);
		break;
	case PEXRCGetEnumTypeInfo:
		GetEnumeratedTypeInfoReply(buf);
		break;
	case PEXRCGetImpDepConstants:
		GetImpDepConstantsReply(buf);
		break;
	case PEXRCGetTableInfo:
		GetTableInfoReply(buf);
		break;
	case PEXRCGetPredefinedEntries:
		GetPredefinedEntriesReply(buf);
		break;
	case PEXRCGetDefinedIndices:
		GetDefinedIndicesReply(buf);
		break;
	case PEXRCGetTableEntry:
		GetTableEntryReply(buf);
		break;
	case PEXRCGetTableEntries:
		GetTableEntriesReply(buf);
		break;
	case PEXRCGetPipelineContext:
		GetPipelineContextReply(buf);
		break;
	case PEXRCGetRendererAttributes:
		GetRendererAttributesReply(buf);
		break;
	case PEXRCGetRendererDynamics:
		GetRendererDynamicsReply(buf);
		break;
	case PEXRCGetStructureInfo:
		GetStructureInfoReply(buf);
		break;
	case PEXRCGetElementInfo:
		GetElementInfoReply(buf);
		break;
	case PEXRCGetStructuresInNetwork:
		GetStructuresInNetworkReply(buf);
		break;
	case PEXRCGetAncestors:
		GetAncestorsReply(buf);
		break;
	case PEXRCGetDescendants:
		GetDescendantsReply(buf);
		break;
	case PEXRCFetchElements:
		FetchElementsReply(buf);
		break;
	case PEXRCElementSearch:
		ElementSearchReply(buf);
		break;
	case PEXRCGetNameSet:
		GetNameSetReply(buf);
		break;
	case PEXRCGetSearchContext:
		GetSearchContextReply(buf);
		break;
	case PEXRCSearchNetwork:
		SearchNetworkReply(buf);
		break;
	case PEXRCGetWorkstationAttributes:
		GetWksInfoReply(buf);
		break;
	case PEXRCGetWorkstationDynamics:
		GetDynamicsReply(buf);
		break;
	case PEXRCGetWorkstationViewRep:
		GetViewRepReply(buf);
		break;
	case PEXRCMapDCtoWC:
		MapDCtoWCReply(buf);
		break;
	case PEXRCMapWCtoDC:
		MapWCtoDCReply(buf);
		break;
	case PEXRCGetWorkstationPostings:
		GetWksPostingsReply(buf);
		break;
	case PEXRCGetPickDevice:
		GetPickDeviceReply(buf);
		break;
	case PEXRCGetPickMeasure:
		GetPickMeasureReply(buf);
		break;
	case PEXRCQueryFont:
		pexqueryfontreply(buf);
		break;
	case PEXRCListFonts:
		pexlistfontsreply(buf);
		break;
	case PEXRCListFontsWithInfo:
		pexlistfontswithinforeply(buf);
		break;
	case PEXRCQueryTextExtents:
		pexquerytextextentsreply(buf);
		break;
	default:
		break;
	}
}

/*
 *
 *
 */

pex_decode_error(fd, buf)
FD fd;
unsigned char *buf;
{
	short error = IByte(&buf[1]);
	switch (error) {
	case BadPEXColorType:
		pexerror_colortype(buf);
		break;
	case BadPEXRendererState:
		pexerror_rendererstate(buf);
		break;
	case BadPEXFloatingPointFormat:
		pexerror_floatingpointformat(buf);
		break;
	case BadPEXLabel:
		pexerror_label(buf);
		break;
	case BadPEXLookupTable:
		pexerror_lookuptable(buf);
		break;
	case BadPEXNameSet:
		pexerror_nameset(buf);
		break;
	case BadPEXPath:
		pexerror_path(buf);
		break;
	case BadPEXFont:
		pexerror_font(buf);
		break;
	case BadPEXWorkstation:
		pexerror_phigswks(buf);
		break;
	case BadPEXPickMeasure:
		pexerror_pickmeasure(buf);
		break;
	case BadPEXPipelineContext:
		pexerror_pipelinecontext(buf);
		break;
	case BadPEXRenderer:
		pexerror_renderer(buf);
		break;
	case BadPEXSearchContext:
		pexerror_searchcontext(buf);
		break;
	case BadPEXStructure:
		pexerror_structure(buf);
		break;
	case BadPEXOutputCommand:
		pexerror_outputcommand(buf);
		break;
	default:
		break;
	}
}

InitializePEX()
{
    LookForPEXFlag = 0;
    PEXCode = 0;
}
